#include <iostream>
#include <geos.h>
#include <BufferParameters.h>
#include <BufferBuilder.h>

void lineBufferBug()
{
   //build weird geometry
   GeometryFactory::unique_ptr gFactory = GeometryFactory::create();
   WKTReader* localWKTReader = new WKTReader(*gFactory);
   Geometry* triangleLine = localWKTReader->read("LINESTRING (600003.5632553970200 6000006.802345209800,600000.4312202869900 6000000.3311080700,600016.5353996580200 6000010.459545190400,600007.3861603239800 6000014.701193110100,600003.5632553970200 6000006.802345209800)");
   Geometry* roundedTriangleLine = localWKTReader->read("LINESTRING (600004 6000007,600000 6000000,600017 6000010,600007 6000015,600004 6000007)");

   //buffer
   using namespace geos::operation::buffer;
   BufferParameters params(0, BufferParameters::CAP_FLAT, BufferParameters::JOIN_ROUND, 1);
   BufferBuilder bufBuilder(params);
   Geometry* shouldBeDonut = bufBuilder.buffer(triangleLine, 0.175);
   BufferBuilder bufBuilder2(params);
   Geometry* isADonut = bufBuilder2.buffer(roundedTriangleLine, 0.175);

   //Show that only one is a donut.
   std::cout << triangleLine->toString() << std::endl;
   std::cout << dynamic_cast<Polygon*>(shouldBeDonut)->getNumInteriorRing() << std::endl; // has no holes -- it's not a Donut :(

   std::cout << roundedTriangleLine->toString() << std::endl;
   std::cout << dynamic_cast<Polygon*>(isADonut)->getNumInteriorRing() << std::endl; // has a hole -- it's a donut! :)

}

int main()
{
   lineBufferBug();

    return 0;
}
